VERSION 4.00
Begin VB.Form BaseForm 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "                                                   "
   ClientHeight    =   4575
   ClientLeft      =   1770
   ClientTop       =   2340
   ClientWidth     =   6225
   ClipControls    =   0   'False
   FillColor       =   &H00FFFFFF&
   Height          =   5265
   Icon            =   "REGEDIT.frx":0000
   Left            =   1710
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   6225
   Top             =   1710
   Width           =   6345
   Begin VB.CommandButton DragLine 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      MousePointer    =   9  'Size W E
      TabIndex        =   1
      Top             =   3960
      Width           =   2355
   End
   Begin RegistryLibDemoCtl.Registry Registry1 
      Left            =   2880
      Top             =   3960
      _Version        =   65536
      _ExtentX        =   741
      _ExtentY        =   741
      _StockProps     =   0
   End
   Begin MSOutl.Outline ValueList 
      Height          =   3375
      Left            =   3000
      TabIndex        =   2
      Top             =   360
      Width           =   3015
      _Version        =   65536
      _ExtentX        =   5318
      _ExtentY        =   5953
      _StockProps     =   77
      BackColor       =   16777215
      BorderStyle     =   0
      MouseIcon       =   "REGEDIT.frx":030A
      Style           =   1
      PicturePlus     =   "REGEDIT.frx":0326
      PictureMinus    =   "REGEDIT.frx":0498
      PictureLeaf     =   "REGEDIT.frx":060A
      PictureOpen     =   "REGEDIT.frx":0B3C
      PictureClosed   =   "REGEDIT.frx":106E
   End
   Begin VB.Image SplitBar 
      Height          =   4395
      Left            =   2520
      MousePointer    =   9  'Size W E
      Picture         =   "REGEDIT.frx":15A0
      Stretch         =   -1  'True
      Top             =   120
      Width           =   90
   End
   Begin MSOutl.Outline KeyList 
      Height          =   3315
      Left            =   120
      TabIndex        =   0
      Top             =   60
      Width           =   2175
      _Version        =   65536
      _ExtentX        =   3836
      _ExtentY        =   5847
      _StockProps     =   77
      BackColor       =   16777215
      BorderStyle     =   0
      MouseIcon       =   "REGEDIT.frx":1A12
      Style           =   5
      PicturePlus     =   "REGEDIT.frx":1A2E
      PictureMinus    =   "REGEDIT.frx":1BA0
      PictureLeaf     =   "REGEDIT.frx":1D12
      PictureOpen     =   "REGEDIT.frx":2244
      PictureClosed   =   "REGEDIT.frx":2776
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&Registry"
      Begin VB.Menu muExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuFind 
      Caption         =   "&Find"
      Begin VB.Menu mnuFKey 
         Caption         =   "Find &Key..."
      End
      Begin VB.Menu mnuFValue 
         Caption         =   "Find &Value..."
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu menuOther 
         Caption         =   "&Other Desaware Products..."
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About Registry Browser..."
      End
   End
End
Attribute VB_Name = "BaseForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
' compilation conditionals


' class globals

Dim btnDown As Boolean
Dim LineWidth As Integer
Dim HasBeenClicked As Boolean
Dim ValueString As String
Dim ValueName As String

#If Win16 Then
    Const outClosed = 0
    Const outOpen = 1
    Const outLeaf = 2
#End If

' Reads the subkeys of a specific key and enters
' them into the outline listbox.
Public Sub ReadChildren(key As String, ListIndex As Integer, level As Integer)
    Dim kidArray() As String
    Dim i As Integer
    Dim n As Integer
    
    n = Registry1.NumOfSubkeys
    ListIndex = ListIndex + 1
    ReDim kidArray(n - 1)
    
    'assuming hasSubItems check is done on expand
    'and opening and keylocking and value reading
    For i = 0 To (n - 1)
        kidArray(i) = Registry1.SubkeyArray(i)
    Next i
    
    If key = "\" Then key = ""
    
    For i = 0 To (n - 1)
        On Error GoTo badkey
        Registry1.CurrentKey = key & "\" & kidArray(i)
        On Error GoTo 0
        
        KeyList.AddItem (kidArray(i)), (ListIndex + i)
        KeyList.Indent(ListIndex + i) = level
        If (Registry1.CurrentKey = "\") Or (Registry1.NumOfSubkeys = 0) Then
            KeyList.PictureType(ListIndex + i) = outLeaf
        Else
            KeyList.PictureType(ListIndex + i) = outClosed
        End If
        GoTo endofloop:
badkey:
' Some keys are not accessable, and cause errors
' when they are queried.  This handeles those keys.
    Debug.Print Err.Number & " - " & Err.Description & " - trying to read a key"
        KeyList.AddItem (kidArray(i)) & " [not accessable]", (ListIndex + i)
        KeyList.Indent(ListIndex + i) = level
        KeyList.PictureType(ListIndex + i) = outLeaf
        Resume endofloop
endofloop:
    Next i
    
    Registry1.CurrentKey = key
    ListIndex = ListIndex - 1
End Sub

' This function retrieves the data associated with
' the Valuename.  It converts it into a string
' that shows the first few bytes of binary data,
' for representaional purposes.
Public Function GetBinaryString(ValueName As String) As String
    Dim temp As String
    Dim i As Integer
    Dim ending As Integer
    Dim RetStr As String
    Const MaxBytes = 8 ' number of bytes in the string
    Dim NumBytes As Long
    Dim num As String
    
    NumBytes = Registry1.GetValueSize(ValueName)
    temp = Registry1.GetValueData(ValueName, True)
    temp = Left$(temp, MaxBytes)
    If (NumBytes > MaxBytes) Then ending = MaxBytes Else ending = NumBytes
    
    ' make sure empty bytes show up
    For i = 1 To ending
        num = Hex$(Asc(Mid(temp, i, 1))) & " "
        If (Len(num) = 1) Then num = "00" Else
        If (Len(num) = 2) Then num = "0" & num
        RetStr = RetStr & num
    Next i
    
    ' show the use that more data actually exists
    If (ending <> MaxBytes) Then
        GetBinaryString = RetStr
    Else
        GetBinaryString = RetStr & "..."
    End If
End Function

' Retrieves the type and data of a registry value
' ValueName and puts it into the value ouline
' listbox with a descriptive icon.
Public Function GetValueString(ValueName As String) As String
    Dim tmpStr As String
    Dim tmpStrArray() As String
    Dim tmpVar As Variant
    
    Select Case Registry1.GetValueType(ValueName)
    Case Reg_None
        GetValueString = "NO TYPE" & " : " & GetBinaryString(ValueName)
        Exit Function
    Case Reg_SZ
        GetValueString = "STRING" & " : " & Registry1.GetValueData(ValueName, True)
        Exit Function
#If Win32 Then
    Case Reg_Expand_SZ
        GetValueString = "EXPAND STRING" & " : " & Registry1.GetValueData(ValueName, True)
        Exit Function
    Case Reg_Binary
        GetValueString = "BINARY" & " : " & GetBinaryString(ValueName)
        Exit Function
    Case Reg_Dword
        GetValueString = "LONG INTEGER" & " : " & Registry1.GetValueData(ValueName, True)
        Exit Function
    Case Reg_Dword_Big_Endian
        GetValueString = "BIG ENDIAN LONG INTEGER" & " : " & Registry1.GetValueData(ValueName, True)
        Exit Function
    Case Reg_Link
        GetValueString = "LINK" & " : " & GetBinaryString(ValueName)
        Exit Function
    Case Reg_Multi_SZ
        GetValueString = "MULTIPLE STRING" & " :" & Registry1.GetValueData(ValueName, True)
        Exit Function
    Case Reg_Resource_List
        GetValueString = "RESOURCE LIST" & " : " & GetBinaryString(ValueName)
        Exit Function
    Case Reg_Full_Resource_Descriptor
        GetValueString = "FULL RESOURCE DESCRIPTOR" & " : " & GetBinaryString(ValueName)
        Exit Function
    Case Reg_Resource_Requirements_List
        GetValueString = "RESOURCE REQUIREMENTS LIST" & " : " & GetBinaryString(ValueName)
        Exit Function
#End If
    End Select

End Function

' This correctly shows the subkeys of a key that
' was expanded.
Private Sub DoExpand(ListIndex As Integer)
    Dim i As Integer
    Dim newIndent As Integer
    
    'assuming hasSubItems check is done on expand
    'and opening and keylocking and value reading
    If (Registry1.NumOfSubkeys = 0) Then Exit Sub
    
    ' Only read the subkeys of a key once, in order
    ' to reduce disk access and improve speed.
    If (KeyList.HasSubItems(ListIndex) = False) Then
        BaseForm.MousePointer = 11
        newIndent = KeyList.Indent(ListIndex) + 1
        ReadChildren Registry1.CurrentKey, ListIndex, newIndent
        BaseForm.MousePointer = 0
    End If
    
    KeyList.Expand(ListIndex) = True
End Sub

' Initialize the positions of the outline listboxes
' and setup the global variables.
Private Sub Form_Load()
    btnDown = False
    HasBeenClicked = False
    
    SplitBar.Top = BaseForm.ScaleTop
    SplitBar.Height = BaseForm.ScaleHeight
    
    ' Move is slightly faster than setting Top
    ' and Left properties.
    KeyList.Move BaseForm.ScaleLeft, BaseForm.ScaleTop
    KeyList.Height = BaseForm.ScaleHeight
    KeyList.Width = SplitBar.Left
    
    ValueList.Move SplitBar.Left + SplitBar.Width, BaseForm.ScaleTop
    ValueList.Height = BaseForm.ScaleHeight
    ValueList.Width = BaseForm.ScaleWidth - SplitBar.Left - SplitBar.Width
    
    DragLine.Width = 10
    DragLine.Visible = False
    
    LineWidth = DragLine.Width * 5
    
    KeyList.AddItem "\"
    KeyList.Indent(0) = 1
    KeyList.ListIndex = 0
    
    On Error GoTo MassiveError
    Registry1.CurrentRoot = hkClassesRoot
    Registry1.CurrentKey = ""
    On Error GoTo 0
    BaseForm.Caption = "Registry Editor - HKEY_CLASSES_ROOT"
    
    If (Registry1.NumOfSubkeys = 0) Then
        KeyList.PictureType(0) = outLeaf
    Else
        KeyList.PictureType(0) = outClosed
    End If
    KeyList_Click

    Exit Sub
MassiveError:
    Debug.Print Err.Number & " - " & Err.Description
    MsgBox "Something is very wrong with the Registry.", vbCritical, "Oh No!"
    Unload BaseForm
End Sub

' Moves the splitbar and the outline listboxes.
Private Sub Form_Resize()
    'check if form is now minimized
    If BaseForm.WindowState = 1 Then Exit Sub
    
    SplitBar.Top = BaseForm.ScaleTop
    SplitBar.Height = BaseForm.ScaleHeight
    If (SplitBar.Left < LineWidth) Then
        SplitBar.Left = LineWidth
    ElseIf (SplitBar.Left > (BaseForm.ScaleWidth - LineWidth)) Then
        SplitBar.Left = BaseForm.ScaleWidth - LineWidth
    End If
    
    KeyList.Move BaseForm.ScaleLeft, BaseForm.ScaleTop
    'KeyList.Top = BaseForm.ScaleTop
    'KeyList.Left = BaseForm.ScaleLeft
    KeyList.Height = BaseForm.ScaleHeight
    KeyList.Width = SplitBar.Left
    
    ValueList.Move SplitBar.Left + SplitBar.Width, BaseForm.ScaleTop
    'ValueList.Top = BaseForm.ScaleTop
    'ValueList.Left = SplitBar.Left + SplitBar.Width
    ValueList.Height = BaseForm.ScaleHeight
    ValueList.Width = BaseForm.ScaleWidth - SplitBar.Left - SplitBar.Width
End Sub

' When a key is clicked, it is highlighted and any
' values it holds are listed in the ValueList.
Private Sub KeyList_Click()
    Dim i As Integer
    Dim n As Integer
    Dim str As String
    Dim name As String

    ValueList.Clear
    
    On Error GoTo badkey
    Registry1.CurrentKey = Right(KeyList.FullPath(KeyList.ListIndex), (Len(KeyList.FullPath(KeyList.ListIndex)) - 1))
    On Error GoTo 0
    
    n = Registry1.NumOfValues - 1
    For i = 0 To n
        name = Registry1.ValueNameArray(i)
        If name = "" Then str = "[Default]" Else str = name
        str = " " & str & " : " & GetValueString(name)
        ValueList.AddItem str
        ValueList.ItemData(ValueList.ListCount - 1) = Registry1.GetValueType(name)
        Select Case ValueList.ItemData(ValueList.ListCount - 1)
        Case 1, 2, 7
            ValueList.PictureType(i) = outOpen
        Case 4, 5
            ValueList.PictureType(i) = outClosed
        Case Else
            ValueList.PictureType(i) = outLeaf
        End Select
    Next i
    
    'reread values according to keylist.listindex
    Exit Sub

badkey:
' Some keys are not accessable.  Any attempt to
' read their values results in an error.  This
' takes care of that.
    Dim OldIndent As Integer
    
    ' Do not delete not accessable keys
    If (Right$(KeyList.List(KeyList.ListIndex), 16) = "[not accessable]") Then Resume exitfromsub
    
    MsgBox "This key no longer exists." & Chr$(13) & "Another program might have erased it.", vbExclamation, "Bad Key"
    OldIndent = KeyList.Indent(KeyList.ListIndex)
    KeyList.RemoveItem (KeyList.ListIndex)
    KeyList.ListIndex = KeyList.ListIndex - 1
    If (KeyList.Indent(KeyList.ListIndex) < OldIndent) And (KeyList.HasSubItems(KeyList.ListIndex) = False) Then
        KeyList.PictureType(KeyList.ListIndex) = outLeaf
    End If
    
    Resume exitfromsub
exitfromsub:
End Sub

' Takes care of collapsing (hiding the subkeys of)
' a key.  The icons of the subkeys are reset.
Private Sub KeyList_Collapse(ListIndex As Integer)
    Dim i As Integer
    
    i = 1
    If (KeyList.HasSubItems(ListIndex) = True) Then
        Do While (KeyList.Indent(ListIndex + i) > KeyList.Indent(ListIndex))
            If (KeyList.PictureType(ListIndex + i) = outOpen) Then
                KeyList.PictureType(ListIndex + i) = outClosed
            End If
            i = i + 1
            If ((ListIndex + i) >= KeyList.ListCount) Then Exit Do
        Loop
    End If
End Sub

' Double-clicking a key either expands or collapses
' (shows or hides the subkeys of) the key, depending
' on whether or not it was expanded at the time.
' When the user double-clicks, the KeyList_Click()
' sub is called first, so there is no need to
' reproduce the code there.
Private Sub KeyList_DblClick()
    HasBeenClicked = True
    If KeyList.PictureType(KeyList.ListIndex) = outLeaf Then Exit Sub
    
    If KeyList.Expand(KeyList.ListIndex) Then
        KeyList.PictureType(KeyList.ListIndex) = outClosed
        KeyList.Expand(KeyList.ListIndex) = False
    Else
        KeyList.PictureType(KeyList.ListIndex) = outOpen
        DoExpand (KeyList.ListIndex)
    End If
    
    'if automatic refresh,reread values according
    'to keylist.listindex
End Sub

' If the outline listbox requests that a key be
' expanded (by, for example, a single click to the
' "root" lines) call my expansion handling routine.
' Ignore the request durring a double-click, as
' expansion is already handled there.
Private Sub KeyList_Expand(ListIndex As Integer)
    If (HasBeenClicked = False) Then
        KeyList_DblClick
    End If
    HasBeenClicked = False
End Sub

Private Sub menuOther_Click()
    Load sdother
    sdother.Show vbModal
End Sub

' The "About" menu item is selected.  Put up a
' descriptive message.
Private Sub mnuAbout_Click()
    Load About
    About.Show vbModal
End Sub


' "Find Key".  Brings up a form that lets the user
' find specfied keys in the current root.
Private Sub mnuFKey_Click()
    Load FindKey
    FindKey.Show
End Sub

' "Find Value".  Bring up a dialog box that allows
' the user to find the keys within the current root
' with a certain value.
Private Sub mnuFValue_Click()
    '
    Load FindValue
    FindValue.Show
End Sub

' "Reg_Classes_Root".  Change the root, and reset
' the key to the root of the new root.  Change the
' title bar of the main window to show which root
' is currently active.
Private Sub mnuRoot_Click()
    BaseForm.Caption = "Registry Editor - HKEY_CLASSES_ROOT"

    On Error GoTo badroot
    Registry1.CurrentRoot = hkClassesRoot
    ValueList.Clear
    KeyList.Clear
    KeyList.AddItem "\"
    KeyList.Indent(0) = 1
    KeyList.ListIndex = 0
    Registry1.CurrentKey = ""
    On Error GoTo 0
    If (Registry1.NumOfSubkeys = 0) Then
        KeyList.PictureType(0) = outLeaf
    Else
        KeyList.PictureType(0) = outClosed
    End If
    KeyList_Click
    Exit Sub

badroot:
    Debug.Print Err.Number & " - " & Err.Description
    Resume exitfromsub
exitfromsub:
End Sub

' "Exit".  This ends the program.
Private Sub muExit_Click()
    Unload BaseForm
    End
End Sub

' This moves the DragLine into the correct position
' when the user clicks on the split bar.  The
' DragLine is actually a command button, because it
' is the only control I could find that would show
' on top of the outline listboxes.
Private Sub SplitBar_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    btnDown = True
    DragLine.Visible = True
    DragLine.Move x + SplitBar.Left, BaseForm.ScaleTop
    'DragLine.Left = x + SplitBar.Left
    'DragLine.Top = BaseForm.ScaleTop
    DragLine.Height = BaseForm.ScaleHeight
End Sub

' This controls the movement of the DragLine while
' the user drags it to a new location.  The
' DragLine is actually a command button, because it
' is the only control I could find that would show
' on top of the outline listboxes.
Private Sub SplitBar_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    If (btnDown = True) Then
        If ((x + SplitBar.Left) < LineWidth) Then
            DragLine.Left = LineWidth
        ElseIf (x + SplitBar.Left) > (BaseForm.ScaleWidth - LineWidth) Then
            DragLine.Left = BaseForm.ScaleWidth - LineWidth
        Else
            DragLine.Left = x + SplitBar.Left
        End If
    End If
End Sub

' When the user stops the movement of the DragLine,
' this subroutine move the splitbar and both
' outline listboxes into their new positions, as
' long as those positions are not to close to either
' edge.
Private Sub SplitBar_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    DragLine.Visible = False
    
    SplitBar.Left = DragLine.Left
    
    'KeyList.Top = BaseForm.ScaleTop
    'KeyList.Left = BaseForm.ScaleLeft
    KeyList.Height = BaseForm.ScaleHeight
    KeyList.Width = SplitBar.Left
    
    ValueList.Move SplitBar.Left + SplitBar.Width, BaseForm.ScaleTop
    'ValueList.Top = BaseForm.ScaleTop
    'ValueList.Left = SplitBar.Left + SplitBar.Width
    ValueList.Height = BaseForm.ScaleHeight
    ValueList.Width = BaseForm.ScaleWidth - SplitBar.Left - SplitBar.Width
    btnDown = False
End Sub
